1#!/bin/sh
2#
3# git-submodule.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7dashless=$(basename "$0" | sed -e 's/-/ /')
8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17OPTIONS_SPEC=
18SUBDIRECTORY_OK=Yes
19. git-sh-setup
20. git-parse-remote
21require_work_tree
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
24
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
29
30command=
31branch=
32force=
33reference=
34cached=
35recursive=
36init=
37files=
38remote=
39nofetch=
40update=
41prefix=
42custom_name=
43depth=
44progress=
45dissociate=
46
47die_if_unmatched ()
48{
49 if test "$1" = "#unmatched"
50 then
51 exit ${2:-1}
52 fi
53}
54
55#
56# Print a submodule configuration setting
57#
58# $1 = submodule name
59# $2 = option name
60# $3 = default value
61#
62# Checks in the usual git-config places first (for overrides),
63# otherwise it falls back on .gitmodules. This allows you to
64# distribute project-wide defaults in .gitmodules, while still
65# customizing individual repositories if necessary. If the option is
66# not in .gitmodules either, print a default value.
67#
68get_submodule_config () {
69 name="$1"
70 option="$2"
71 default="$3"
72 value=$(git config submodule."$name"."$option")
73 if test -z "$value"
74 then
75 value=$(git submodule--helper config submodule."$name"."$option")
76 fi
77 printf '%s' "${value:-$default}"
78}
79
80isnumber()
81{
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83}
84
85# Given a full hex object ID, is this the zero OID?
86is_zero_oid () {
87 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
88}
89
90# Sanitize the local git environment for use within a submodule. We
91# can't simply use clear_local_git_env since we want to preserve some
92# of the settings from GIT_CONFIG_PARAMETERS.
93sanitize_submodule_env()
94{
95 save_config=$GIT_CONFIG_PARAMETERS
96 clear_local_git_env
97 GIT_CONFIG_PARAMETERS=$save_config
98 export GIT_CONFIG_PARAMETERS
99}
100
101#
102# Add a new submodule to the working tree, .gitmodules and the index
103#
104# $@ = repo path
105#
106# optional branch is stored in global branch variable
107#
108cmd_add()
109{
110 # parse $args after "submodule ... add".
111 reference_path=
112 while test $# -ne 0
113 do
114 case "$1" in
115 -b | --branch)
116 case "$2" in '') usage ;; esac
117 branch=$2
118 shift
119 ;;
120 -f | --force)
121 force=$1
122 ;;
123 -q|--quiet)
124 GIT_QUIET=1
125 ;;
126 --progress)
127 progress=1
128 ;;
129 --reference)
130 case "$2" in '') usage ;; esac
131 reference_path=$2
132 shift
133 ;;
134 --reference=*)
135 reference_path="${1#--reference=}"
136 ;;
137 --dissociate)
138 dissociate=1
139 ;;
140 --name)
141 case "$2" in '') usage ;; esac
142 custom_name=$2
143 shift
144 ;;
145 --depth)
146 case "$2" in '') usage ;; esac
147 depth="--depth=$2"
148 shift
149 ;;
150 --depth=*)
151 depth=$1
152 ;;
153 --)
154 shift
155 break
156 ;;
157 -*)
158 usage
159 ;;
160 *)
161 break
162 ;;
163 esac
164 shift
165 done
166
167 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
168 then
169 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
170 fi
171
172 if test -n "$reference_path"
173 then
174 is_absolute_path "$reference_path" ||
175 reference_path="$wt_prefix$reference_path"
176
177 reference="--reference=$reference_path"
178 fi
179
180 repo=$1
181 sm_path=$2
182
183 if test -z "$sm_path"; then
184 sm_path=$(printf '%s\n' "$repo" |
185 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
186 fi
187
188 if test -z "$repo" || test -z "$sm_path"; then
189 usage
190 fi
191
192 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
193
194 # assure repo is absolute or relative to parent
195 case "$repo" in
196 ./*|../*)
197 test -z "$wt_prefix" ||
198 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
199
200 # dereference source url relative to parent's url
201 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
202 ;;
203 *:*|/*)
204 # absolute url
205 realrepo=$repo
206 ;;
207 *)
208 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
209 ;;
210 esac
211
212 # normalize path:
213 # multiple //; leading ./; /./; /../; trailing /
214 sm_path=$(printf '%s/\n' "$sm_path" |
215 sed -e '
216 s|//*|/|g
217 s|^\(\./\)*||
218 s|/\(\./\)*|/|g
219 :start
220 s|\([^/]*\)/\.\./||
221 tstart
222 s|/*$||
223 ')
224 if test -z "$force"
225 then
226 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
227 die "$(eval_gettext "'\$sm_path' already exists in the index")"
228 else
229 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
230 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
231 fi
232
233 if test -z "$force" &&
234 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
235 then
236 eval_gettextln "The following path is ignored by one of your .gitignore files:
237\$sm_path
238Use -f if you really want to add it." >&2
239 exit 1
240 fi
241
242 if test -n "$custom_name"
243 then
244 sm_name="$custom_name"
245 else
246 sm_name="$sm_path"
247 fi
248
249 if ! git submodule--helper check-name "$sm_name"
250 then
251 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
252 fi
253
254 # perhaps the path exists and is already a git repo, else clone it
255 if test -e "$sm_path"
256 then
257 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
258 then
259 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
260 else
261 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
262 fi
263
264 else
265 if test -d ".git/modules/$sm_name"
266 then
267 if test -z "$force"
268 then
269 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
270 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
271 die "$(eval_gettextln "\
272If you want to reuse this local git directory instead of cloning again from
273 \$realrepo
274use the '--force' option. If the local git directory is not the correct repo
275or you are unsure what this means choose another name with the '--name' option.")"
276 else
277 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
278 fi
279 fi
280 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
281 (
282 sanitize_submodule_env
283 cd "$sm_path" &&
284 # ash fails to wordsplit ${branch:+-b "$branch"...}
285 case "$branch" in
286 '') git checkout -f -q ;;
287 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
288 esac
289 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
290 fi
291 git config submodule."$sm_name".url "$realrepo"
292
293 git add --no-warn-embedded-repo $force "$sm_path" ||
294 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
295
296 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
297 git submodule--helper config submodule."$sm_name".url "$repo" &&
298 if test -n "$branch"
299 then
300 git submodule--helper config submodule."$sm_name".branch "$branch"
301 fi &&
302 git add --force .gitmodules ||
303 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
304
305 # NEEDSWORK: In a multi-working-tree world, this needs to be
306 # set in the per-worktree config.
307 if git config --get submodule.active >/dev/null
308 then
309 # If the submodule being adding isn't already covered by the
310 # current configured pathspec, set the submodule's active flag
311 if ! git submodule--helper is-active "$sm_path"
312 then
313 git config submodule."$sm_name".active "true"
314 fi
315 else
316 git config submodule."$sm_name".active "true"
317 fi
318}
319
320#
321# Execute an arbitrary command sequence in each checked out
322# submodule
323#
324# $@ = command to execute
325#
326cmd_foreach()
327{
328 # parse $args after "submodule ... foreach".
329 while test $# -ne 0
330 do
331 case "$1" in
332 -q|--quiet)
333 GIT_QUIET=1
334 ;;
335 --recursive)
336 recursive=1
337 ;;
338 -*)
339 usage
340 ;;
341 *)
342 break
343 ;;
344 esac
345 shift
346 done
347
348 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
349}
350
351#
352# Register submodules in .git/config
353#
354# $@ = requested paths (default to all)
355#
356cmd_init()
357{
358 # parse $args after "submodule ... init".
359 while test $# -ne 0
360 do
361 case "$1" in
362 -q|--quiet)
363 GIT_QUIET=1
364 ;;
365 --)
366 shift
367 break
368 ;;
369 -*)
370 usage
371 ;;
372 *)
373 break
374 ;;
375 esac
376 shift
377 done
378
379 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
380}
381
382#
383# Unregister submodules from .git/config and remove their work tree
384#
385cmd_deinit()
386{
387 # parse $args after "submodule ... deinit".
388 deinit_all=
389 while test $# -ne 0
390 do
391 case "$1" in
392 -f|--force)
393 force=$1
394 ;;
395 -q|--quiet)
396 GIT_QUIET=1
397 ;;
398 --all)
399 deinit_all=t
400 ;;
401 --)
402 shift
403 break
404 ;;
405 -*)
406 usage
407 ;;
408 *)
409 break
410 ;;
411 esac
412 shift
413 done
414
415 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
416}
417
418is_tip_reachable () (
419 sanitize_submodule_env &&
420 cd "$1" &&
421 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
422 test -z "$rev"
423)
424
425fetch_in_submodule () (
426 sanitize_submodule_env &&
427 cd "$1" &&
428 case "$2" in
429 '')
430 git fetch ;;
431 *)
432 shift
433 git fetch $(get_default_remote) "$@" ;;
434 esac
435)
436
437#
438# Update each submodule path to correct revision, using clone and checkout as needed
439#
440# $@ = requested paths (default to all)
441#
442cmd_update()
443{
444 # parse $args after "submodule ... update".
445 while test $# -ne 0
446 do
447 case "$1" in
448 -q|--quiet)
449 GIT_QUIET=1
450 ;;
451 -v)
452 GIT_QUIET=0
453 ;;
454 --progress)
455 progress=1
456 ;;
457 -i|--init)
458 init=1
459 ;;
460 --remote)
461 remote=1
462 ;;
463 -N|--no-fetch)
464 nofetch=1
465 ;;
466 -f|--force)
467 force=$1
468 ;;
469 -r|--rebase)
470 update="rebase"
471 ;;
472 --reference)
473 case "$2" in '') usage ;; esac
474 reference="--reference=$2"
475 shift
476 ;;
477 --reference=*)
478 reference="$1"
479 ;;
480 --dissociate)
481 dissociate=1
482 ;;
483 -m|--merge)
484 update="merge"
485 ;;
486 --recursive)
487 recursive=1
488 ;;
489 --checkout)
490 update="checkout"
491 ;;
492 --recommend-shallow)
493 recommend_shallow="--recommend-shallow"
494 ;;
495 --no-recommend-shallow)
496 recommend_shallow="--no-recommend-shallow"
497 ;;
498 --depth)
499 case "$2" in '') usage ;; esac
500 depth="--depth=$2"
501 shift
502 ;;
503 --depth=*)
504 depth=$1
505 ;;
506 -j|--jobs)
507 case "$2" in '') usage ;; esac
508 jobs="--jobs=$2"
509 shift
510 ;;
511 --jobs=*)
512 jobs=$1
513 ;;
514 --)
515 shift
516 break
517 ;;
518 -*)
519 usage
520 ;;
521 *)
522 break
523 ;;
524 esac
525 shift
526 done
527
528 if test -n "$init"
529 then
530 cmd_init "--" "$@" || return
531 fi
532
533 {
534 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
535 ${progress:+"--progress"} \
536 ${wt_prefix:+--prefix "$wt_prefix"} \
537 ${prefix:+--recursive-prefix "$prefix"} \
538 ${update:+--update "$update"} \
539 ${reference:+"$reference"} \
540 ${dissociate:+"--dissociate"} \
541 ${depth:+--depth "$depth"} \
542 $recommend_shallow \
543 $jobs \
544 -- \
545 "$@" || echo "#unmatched" $?
546 } | {
547 err=
548 while read -r quickabort sha1 just_cloned sm_path
549 do
550 die_if_unmatched "$quickabort" "$sha1"
551
552 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
553
554 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
555
556 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
557
558 if test $just_cloned -eq 1
559 then
560 subsha1=
561 else
562 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
563 git rev-parse --verify HEAD) ||
564 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
565 fi
566
567 if test -n "$remote"
568 then
569 branch=$(git submodule--helper remote-branch "$sm_path")
570 if test -z "$nofetch"
571 then
572 # Fetch remote before determining tracking $sha1
573 fetch_in_submodule "$sm_path" $depth ||
574 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
575 fi
576 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
577 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
578 git rev-parse --verify "${remote_name}/${branch}") ||
579 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
580 fi
581
582 if test "$subsha1" != "$sha1" || test -n "$force"
583 then
584 subforce=$force
585 # If we don't already have a -f flag and the submodule has never been checked out
586 if test -z "$subsha1" && test -z "$force"
587 then
588 subforce="-f"
589 fi
590
591 if test -z "$nofetch"
592 then
593 # Run fetch only if $sha1 isn't present or it
594 # is not reachable from a ref.
595 is_tip_reachable "$sm_path" "$sha1" ||
596 fetch_in_submodule "$sm_path" $depth ||
597 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
598
599 # Now we tried the usual fetch, but $sha1 may
600 # not be reachable from any of the refs
601 is_tip_reachable "$sm_path" "$sha1" ||
602 fetch_in_submodule "$sm_path" $depth "$sha1" ||
603 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
604 fi
605
606 must_die_on_failure=
607 case "$update_module" in
608 checkout)
609 command="git checkout $subforce -q"
610 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
611 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
612 ;;
613 rebase)
614 command="git rebase"
615 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
616 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
617 must_die_on_failure=yes
618 ;;
619 merge)
620 command="git merge"
621 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
622 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
623 must_die_on_failure=yes
624 ;;
625 !*)
626 command="${update_module#!}"
627 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
628 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
629 must_die_on_failure=yes
630 ;;
631 *)
632 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
633 esac
634
635 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
636 then
637 say "$say_msg"
638 elif test -n "$must_die_on_failure"
639 then
640 die_with_status 2 "$die_msg"
641 else
642 err="${err};$die_msg"
643 continue
644 fi
645 fi
646
647 if test -n "$recursive"
648 then
649 (
650 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
651 wt_prefix=
652 sanitize_submodule_env
653 cd "$sm_path" &&
654 eval cmd_update
655 )
656 res=$?
657 if test $res -gt 0
658 then
659 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
660 if test $res -ne 2
661 then
662 err="${err};$die_msg"
663 continue
664 else
665 die_with_status $res "$die_msg"
666 fi
667 fi
668 fi
669 done
670
671 if test -n "$err"
672 then
673 OIFS=$IFS
674 IFS=';'
675 for e in $err
676 do
677 if test -n "$e"
678 then
679 echo >&2 "$e"
680 fi
681 done
682 IFS=$OIFS
683 exit 1
684 fi
685 }
686}
687
688#
689# Show commit summary for submodules in index or working tree
690#
691# If '--cached' is given, show summary between index and given commit,
692# or between working tree and given commit
693#
694# $@ = [commit (default 'HEAD'),] requested paths (default all)
695#
696cmd_summary() {
697 summary_limit=-1
698 for_status=
699 diff_cmd=diff-index
700
701 # parse $args after "submodule ... summary".
702 while test $# -ne 0
703 do
704 case "$1" in
705 --cached)
706 cached="$1"
707 ;;
708 --files)
709 files="$1"
710 ;;
711 --for-status)
712 for_status="$1"
713 ;;
714 -n|--summary-limit)
715 summary_limit="$2"
716 isnumber "$summary_limit" || usage
717 shift
718 ;;
719 --summary-limit=*)
720 summary_limit="${1#--summary-limit=}"
721 isnumber "$summary_limit" || usage
722 ;;
723 --)
724 shift
725 break
726 ;;
727 -*)
728 usage
729 ;;
730 *)
731 break
732 ;;
733 esac
734 shift
735 done
736
737 test $summary_limit = 0 && return
738
739 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
740 then
741 head=$rev
742 test $# = 0 || shift
743 elif test -z "$1" || test "$1" = "HEAD"
744 then
745 # before the first commit: compare with an empty tree
746 head=$(git hash-object -w -t tree --stdin </dev/null)
747 test -z "$1" || shift
748 else
749 head="HEAD"
750 fi
751
752 if [ -n "$files" ]
753 then
754 test -n "$cached" &&
755 die "$(gettext "The --cached option cannot be used with the --files option")"
756 diff_cmd=diff-files
757 head=
758 fi
759
760 cd_to_toplevel
761 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
762 # Get modified modules cared by user
763 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
764 sane_egrep '^:([0-7]* )?160000' |
765 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
766 do
767 # Always show modules deleted or type-changed (blob<->module)
768 if test "$status" = D || test "$status" = T
769 then
770 printf '%s\n' "$sm_path"
771 continue
772 fi
773 # Respect the ignore setting for --for-status.
774 if test -n "$for_status"
775 then
776 name=$(git submodule--helper name "$sm_path")
777 ignore_config=$(get_submodule_config "$name" ignore none)
778 test $status != A && test $ignore_config = all && continue
779 fi
780 # Also show added or modified modules which are checked out
781 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
782 printf '%s\n' "$sm_path"
783 done
784 )
785
786 test -z "$modules" && return
787
788 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
789 sane_egrep '^:([0-7]* )?160000' |
790 cut -c2- |
791 while read -r mod_src mod_dst sha1_src sha1_dst status name
792 do
793 if test -z "$cached" &&
794 is_zero_oid $sha1_dst
795 then
796 case "$mod_dst" in
797 160000)
798 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
799 ;;
800 100644 | 100755 | 120000)
801 sha1_dst=$(git hash-object $name)
802 ;;
803 000000)
804 ;; # removed
805 *)
806 # unexpected type
807 eval_gettextln "unexpected mode \$mod_dst" >&2
808 continue ;;
809 esac
810 fi
811 missing_src=
812 missing_dst=
813
814 test $mod_src = 160000 &&
815 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
816 missing_src=t
817
818 test $mod_dst = 160000 &&
819 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
820 missing_dst=t
821
822 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
823
824 total_commits=
825 case "$missing_src,$missing_dst" in
826 t,)
827 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
828 ;;
829 ,t)
830 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
831 ;;
832 t,t)
833 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
834 ;;
835 *)
836 errmsg=
837 total_commits=$(
838 if test $mod_src = 160000 && test $mod_dst = 160000
839 then
840 range="$sha1_src...$sha1_dst"
841 elif test $mod_src = 160000
842 then
843 range=$sha1_src
844 else
845 range=$sha1_dst
846 fi
847 GIT_DIR="$name/.git" \
848 git rev-list --first-parent $range -- | wc -l
849 )
850 total_commits=" ($(($total_commits + 0)))"
851 ;;
852 esac
853
854 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
855 echo $sha1_src | cut -c1-7)
856 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
857 echo $sha1_dst | cut -c1-7)
858
859 if test $status = T
860 then
861 blob="$(gettext "blob")"
862 submodule="$(gettext "submodule")"
863 if test $mod_dst = 160000
864 then
865 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
866 else
867 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
868 fi
869 else
870 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
871 fi
872 if test -n "$errmsg"
873 then
874 # Don't give error msg for modification whose dst is not submodule
875 # i.e. deleted or changed to blob
876 test $mod_dst = 160000 && echo "$errmsg"
877 else
878 if test $mod_src = 160000 && test $mod_dst = 160000
879 then
880 limit=
881 test $summary_limit -gt 0 && limit="-$summary_limit"
882 GIT_DIR="$name/.git" \
883 git log $limit --pretty='format: %m %s' \
884 --first-parent $sha1_src...$sha1_dst
885 elif test $mod_dst = 160000
886 then
887 GIT_DIR="$name/.git" \
888 git log --pretty='format: > %s' -1 $sha1_dst
889 else
890 GIT_DIR="$name/.git" \
891 git log --pretty='format: < %s' -1 $sha1_src
892 fi
893 echo
894 fi
895 echo
896 done
897}
898#
899# List all submodules, prefixed with:
900# - submodule not initialized
901# + different revision checked out
902#
903# If --cached was specified the revision in the index will be printed
904# instead of the currently checked out revision.
905#
906# $@ = requested paths (default to all)
907#
908cmd_status()
909{
910 # parse $args after "submodule ... status".
911 while test $# -ne 0
912 do
913 case "$1" in
914 -q|--quiet)
915 GIT_QUIET=1
916 ;;
917 --cached)
918 cached=1
919 ;;
920 --recursive)
921 recursive=1
922 ;;
923 --)
924 shift
925 break
926 ;;
927 -*)
928 usage
929 ;;
930 *)
931 break
932 ;;
933 esac
934 shift
935 done
936
937 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
938}
939#
940# Sync remote urls for submodules
941# This makes the value for remote.$remote.url match the value
942# specified in .gitmodules.
943#
944cmd_sync()
945{
946 while test $# -ne 0
947 do
948 case "$1" in
949 -q|--quiet)
950 GIT_QUIET=1
951 shift
952 ;;
953 --recursive)
954 recursive=1
955 shift
956 ;;
957 --)
958 shift
959 break
960 ;;
961 -*)
962 usage
963 ;;
964 *)
965 break
966 ;;
967 esac
968 done
969
970 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
971}
972
973cmd_absorbgitdirs()
974{
975 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
976}
977
978# This loop parses the command line arguments to find the
979# subcommand name to dispatch. Parsing of the subcommand specific
980# options are primarily done by the subcommand implementations.
981# Subcommand specific options such as --branch and --cached are
982# parsed here as well, for backward compatibility.
983
984while test $# != 0 && test -z "$command"
985do
986 case "$1" in
987 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
988 command=$1
989 ;;
990 -q|--quiet)
991 GIT_QUIET=1
992 ;;
993 -b|--branch)
994 case "$2" in
995 '')
996 usage
997 ;;
998 esac
999 branch="$2"; shift
1000 ;;
1001 --cached)
1002 cached="$1"
1003 ;;
1004 --)
1005 break
1006 ;;
1007 -*)
1008 usage
1009 ;;
1010 *)
1011 break
1012 ;;
1013 esac
1014 shift
1015done
1016
1017# No command word defaults to "status"
1018if test -z "$command"
1019then
1020 if test $# = 0
1021 then
1022 command=status
1023 else
1024 usage
1025 fi
1026fi
1027
1028# "-b branch" is accepted only by "add"
1029if test -n "$branch" && test "$command" != add
1030then
1031 usage
1032fi
1033
1034# "--cached" is accepted only by "status" and "summary"
1035if test -n "$cached" && test "$command" != status && test "$command" != summary
1036then
1037 usage
1038fi
1039
1040"cmd_$command" "$@"